From e8bb053df384c1ddc18fa87f1b96aea895e0c07d Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 22 2017 17:24:04 +0000
Subject: [PATCH 763/1001] Move a function in the view utils module


And other minor cleanups

---

diff --git a/hubs/tests/test_fedora_hubs_flask_api.py b/hubs/tests/test_fedora_hubs_flask_api.py
index 97c4911..812159a 100644
--- a/hubs/tests/test_fedora_hubs_flask_api.py
+++ b/hubs/tests/test_fedora_hubs_flask_api.py
@@ -271,6 +271,11 @@ class HubsAPITest(hubs.tests.APPTest):
             self.assertIn('data-url="/ralph/w/memberships/', page_html)
 
     def test_hub_add_widget_post_valid_widget_name_with_args(self):
+        self.assertEqual(
+            hubs.models.Widget.query.filter(
+                hubs.models.Hub.name == "ralph",
+                hubs.models.Widget.plugin == "about",
+            ).count(), 1)
         user = tests.FakeAuthorization('ralph')
         with tests.auth_set(app, user):
             data = {
@@ -279,12 +284,15 @@ class HubsAPITest(hubs.tests.APPTest):
                 }
             result = self.app.post('/ralph/add/about', data=data,
                                    follow_redirects=False)
-            self.assertEqual(result.status_code, 302)
-            self.assertEqual(urlparse(result.location).path, "/ralph/edit")
-            result = self.app.get('/ralph/edit')
             self.assertEqual(result.status_code, 200)
-            page_html = result.get_data(as_text=True)
-            self.assertIn('data-url="/ralph/w/about/', page_html)
+            self.assertEqual(
+                json.loads(result.get_data(as_text=True)),
+                {"status": "ADDED"})
+            self.assertEqual(
+                hubs.models.Widget.query.filter(
+                    hubs.models.Hub.name == "ralph",
+                    hubs.models.Widget.plugin == "about",
+                ).count(), 2)
 
     def test_hub_edit_widget_get_logged_in(self):
         user = tests.FakeAuthorization('ralph')
diff --git a/hubs/tests/test_widgets/test_about.py b/hubs/tests/test_widgets/test_about.py
index 35ff9fa..7865a34 100644
--- a/hubs/tests/test_widgets/test_about.py
+++ b/hubs/tests/test_widgets/test_about.py
@@ -12,7 +12,7 @@ class TestBadges(hubs.tests.test_widgets.WidgetTest):
 
     def test_data_simple(self):
         widget = self.widget_instance('ralph', self.plugin)
-        response = self.app.get('/ralph/%i/json/' % widget.idx)
+        response = self.app.get('/ralph/%i/json' % widget.idx)
         assert response.status_code == 200, response.status_code
         data = json.loads(response.get_data(as_text=True))
         self.assertDictEqual(data['data'], {
diff --git a/hubs/tests/test_widgets/test_badges.py b/hubs/tests/test_widgets/test_badges.py
index f8ae5b6..45e1ce8 100644
--- a/hubs/tests/test_widgets/test_badges.py
+++ b/hubs/tests/test_widgets/test_badges.py
@@ -11,7 +11,7 @@ class TestBadges(hubs.tests.test_widgets.WidgetTest):
 
     def test_data_simple(self):
         widget = self.widget_instance('ralph', self.plugin)
-        response = self.app.get('/ralph/%i/json/' % widget.idx)
+        response = self.app.get('/ralph/%i/json' % widget.idx)
         assert response.status_code == 200, response.status_code
         data = json.loads(response.get_data(as_text=True))
         self.assertEquals(data['plugin'], 'badges')
diff --git a/hubs/tests/test_widgets/test_fedmsgstats.py b/hubs/tests/test_widgets/test_fedmsgstats.py
index 6bb9cca..cb3d5d3 100644
--- a/hubs/tests/test_widgets/test_fedmsgstats.py
+++ b/hubs/tests/test_widgets/test_fedmsgstats.py
@@ -10,7 +10,7 @@ class TestFedmsgStats(hubs.tests.test_widgets.WidgetTest):
 
     def test_data_simple(self):
         widget = self.widget_instance('ralph', self.plugin)
-        response = self.app.get('/ralph/%i/json/' % widget.idx)
+        response = self.app.get('/ralph/%i/json' % widget.idx)
         assert response.status_code == 200, response.status_code
         data = json.loads(response.get_data(as_text=True))
         self.assertDictEqual(data['data'], {
diff --git a/hubs/tests/test_widgets/test_library.py b/hubs/tests/test_widgets/test_library.py
index 88db8b0..a41e60e 100644
--- a/hubs/tests/test_widgets/test_library.py
+++ b/hubs/tests/test_widgets/test_library.py
@@ -10,7 +10,7 @@ class TestLibrary(hubs.tests.test_widgets.WidgetTest):
 
     def test_data_simple(self):
         widget = self.widget_instance('ralph', self.plugin)
-        response = self.app.get('/ralph/%i/json/' % widget.idx)
+        response = self.app.get('/ralph/%i/json' % widget.idx)
         self.assertEqual(response.status_code, 200)
         data = json.loads(response.get_data(as_text=True))
         expected_dict = {
diff --git a/hubs/tests/test_widgets/test_meetings.py b/hubs/tests/test_widgets/test_meetings.py
index 859bfb9..78c41b9 100644
--- a/hubs/tests/test_widgets/test_meetings.py
+++ b/hubs/tests/test_widgets/test_meetings.py
@@ -11,7 +11,7 @@ class TestMeetings(hubs.tests.test_widgets.WidgetTest):
     def test_data_simple(self):
         team = 'i18n'
         widget = self.widget_instance(team, self.plugin)
-        response = self.app.get('/%s/%i/json/' % (team, widget.idx))
+        response = self.app.get('/%s/%i/json' % (team, widget.idx))
         self.assertEqual(200, response.status_code)
         data = json.loads(response.get_data(as_text=True))
         calendar_name = data['data']['calendar']
diff --git a/hubs/views/utils.py b/hubs/views/utils.py
index 32b544b..2aecbb8 100644
--- a/hubs/views/utils.py
+++ b/hubs/views/utils.py
@@ -1,5 +1,6 @@
 from __future__ import unicode_literals
 
+import datetime
 import flask
 import functools
 import hubs.models
@@ -38,6 +39,51 @@ def get_widget_instance(hub, idx, session=None):
         flask.abort(404)
 
 
+class WidgetConfigError(Exception):
+    pass
+
+
+def create_widget_instance(hub, widget, position):
+    """View helper to instanciate a widget on a hub."""
+    widget_instance = hubs.models.Widget(
+        hub=hub, plugin=widget.name, index=-1,
+        left=(position == 'left'))
+    flask.g.db.add(widget_instance)
+    flask.g.db.flush()  # will populate Widget.config
+    try:
+        configure_widget_instance(widget_instance)
+    except WidgetConfigError as e:
+        flask.flash(e.args[0], "error")
+    else:
+        flask.flash("The widget has been added.")
+
+
+def configure_widget_instance(widget_instance):
+    config = {}
+    for param in widget_instance.module.get_parameters():
+        val = flask.request.form.get(param.name)
+        if not val:
+            raise WidgetConfigError(
+                'You must provide a value for: %s' % param.name)
+        try:
+            config[param.name] = param.validator.from_string(val)
+        except Exception as err:
+            raise WidgetConfigError('Invalid data provided, error: %s' % err)
+    # Updating in-place is not supported, it's a class property.
+    cur_config = widget_instance.config or {}
+    cur_config = cur_config.copy()
+    cur_config.update(config)
+    widget_instance.config = cur_config
+    # TODO: use a SQLAlchemy signal here
+    widget_instance.hub.last_edited = datetime.datetime.utcnow()
+    try:
+        flask.g.db.commit()
+    except Exception as err:
+        raise WidgetConfigError(
+            'Could not save the configuration to the database '
+            'if the error persists, please warn an admin')
+
+
 def authenticated():
     """ Utility function checking if the current auth is set or not."""
     return hasattr(flask.g, 'auth') \
@@ -69,4 +115,3 @@ def is_safe_url(target):
         urlparse.urljoin(flask.request.host_url, target))
     return test_url.scheme in ('http', 'https') and \
         ref_url.netloc == test_url.netloc
-
diff --git a/hubs/views/widget.py b/hubs/views/widget.py
index 02c06c8..637ec25 100644
--- a/hubs/views/widget.py
+++ b/hubs/views/widget.py
@@ -4,19 +4,12 @@ import datetime
 import flask
 
 from hubs.app import app
-from hubs.models import Widget
 from hubs.widgets import registry
 from pkg_resources import resource_isdir
-from .utils import get_hub, get_widget_instance, login_required
-
-
-@app.route('/<hub>/<int:idx>/json')
-@app.route('/<hub>/<int:idx>/json/')
-def widget_json(hub, idx):
-    widget = get_widget_instance(hub, idx)
-    response = flask.jsonify(widget.__json__())
-    # TODO -- modify headers with response.headers['X-fedora-hubs-wat'] = 'foo'
-    return response
+from .utils import (
+    create_widget_instance, configure_widget_instance, get_hub,
+    get_widget_instance, login_required, WidgetConfigError,
+    )
 
 
 @app.route('/<name>/add', methods=['GET', 'POST'])
@@ -56,6 +49,8 @@ def hub_add_widget(name):
 @app.route('/<hub>/add/<widget>', methods=['GET', 'POST'])
 def widget_add(hub, widget):
     hub = get_hub(hub)
+    # Use request.values instead of request.form to allow the position to be
+    # passed in the query string.
     position = flask.request.values.get('position', '')
     if position not in ['right', 'left']:
         flask.abort(400, 'Invalid position provided')
@@ -65,7 +60,7 @@ def widget_add(hub, widget):
         flask.abort(404, 'Unknown widget: %s' % widget)
     if flask.request.method == 'POST':
         create_widget_instance(hub, widget, position)
-        return flask.redirect(flask.url_for('hub_edit', name=hub.name))
+        return flask.jsonify({"status": "ADDED"})
     return flask.render_template(
         'widget_add.html',
         hub=hub,
@@ -73,100 +68,36 @@ def widget_add(hub, widget):
         position=position,
     )
 
-def create_widget_instance(hub, widget, position):
-    """View helper to instanciate a widget on a hub."""
-    widget_instance = Widget(
-        hub=hub, plugin=widget.name, index=-1,
-        left=(position == 'left'))
-    config = {}
-    for param in widget.get_parameters():
-        val = flask.request.form.get(param.name)
-        if not val:
-            flask.flash(
-                'You must provide a value for: %s' % param.name, 'error')
-            return
-        try:
-            config[param.name] = param.validator.from_string(val)
-        except Exception as err:
-            flask.flash('Invalid data provided, error: %s' % err, 'error')
-            return
-    widget_instance.config = config
-    try:
-        flask.g.db.add(widget_instance)
-        flask.g.db.flush()
-        # TODO: use a SQLAlchemy signal here
-        hub.last_edited = datetime.datetime.utcnow()
-        flask.g.db.commit()
-    except Exception as err:
-        flask.flash(
-            'Could not save the configuration to the database '
-            'if the error persists, please warn an admin',
-            'error')
-    else:
-        flask.flash("The widget has been added.")
-
 
 @app.route('/<hub>/<int:idx>/edit', methods=['GET', 'POST'])
 @login_required
 def widget_edit(hub, idx):
-    if flask.request.method == 'POST':
-        return widget_edit_post(hub, idx)
-    else:
-        return widget_edit_get(hub, idx)
-
-
-def widget_edit_get(hub, idx):
-    widget_instance = get_widget_instance(hub, idx)
-    return flask.render_template(
-        'widget_edit.html',
-        hub=widget_instance.hub,
-        widget_instance=widget_instance,
-    )
-
-
-def widget_edit_post(hub, idx):
     widget_instance = get_widget_instance(hub, idx)
-    error = False
-    config = {}
-    for param in widget_instance.module.get_parameters():
-        val = flask.request.form.get(param.name)
-        if not val:
-            flask.flash(
-                'You must provide a value for: %s' % param.name, 'error')
-            error = True
-            break
-        try:
-            config[param.name] = param.validator.from_string(val)
-        except Exception as err:
-            flask.flash('Invalid data provided, error: %s' % err, 'error')
-            error = True
-    if not error:
-        # Updating in-place is not supported, it's a class property.
-        cur_config = widget_instance.config.copy()
-        cur_config.update(config)
-        widget_instance.config = cur_config
-        widget_instance.hub.last_edited = datetime.datetime.utcnow()
-        flask.g.db.add(widget_instance)
+    if flask.request.method == 'POST':
         try:
-            flask.g.db.commit()
-        except Exception as err:
-            flask.flash(
-                'Could not save the configuration to the database '
-                'if the error persists, please warn an admin',
-                'error')
-    return flask.redirect(flask.url_for('hub_edit', name=hub))
+            configure_widget_instance(widget_instance)
+        except WidgetConfigError as e:
+            flask.flash(e.args[0], "error")
+        else:
+            flask.flash("The widget has been updated.")
+        return flask.redirect(flask.url_for('hub_edit', name=hub))
+    else:
+        return flask.render_template(
+            'widget_edit.html',
+            hub=widget_instance.hub,
+            widget_instance=widget_instance,
+        )
 
 
-@app.route('/<hub>/<int:idx>/delete/', methods=['POST'])
 @app.route('/<hub>/<int:idx>/delete', methods=['POST'])
 @login_required
 def widget_edit_delete(hub, idx):
     ''' Remove a widget from a hub. '''
-    widget = get_widget_instance(hub, idx)
-    flask.g.db.delete(widget)
+    widget_instance = get_widget_instance(hub, idx)
+    flask.g.db.delete(widget_instance)
     try:
         flask.g.db.commit()
-    except Exception as err:
+    except Exception:
         flask.flash(
             'Could not delete this widget from this hub in the database '
             'if the error persists, please warn an admin',
@@ -174,7 +105,14 @@ def widget_edit_delete(hub, idx):
     return flask.redirect(flask.url_for('hub_edit', name=hub))
 
 
-@app.route('/source/<name>/')
+@app.route('/<hub>/<int:idx>/json')
+def widget_json(hub, idx):
+    widget = get_widget_instance(hub, idx)
+    response = flask.jsonify(widget.__json__())
+    # TODO -- modify headers with response.headers['X-fedora-hubs-wat'] = 'foo'
+    return response
+
+
 @app.route('/source/<name>')
 def widget_source(name):
     try:
@@ -189,4 +127,3 @@ def widget_source(name):
         widget_url += ".py"
     url = "/".join([app.config.get('SOURCE_URL'), widget_url])
     return flask.redirect(url)
-

